
#ifndef
#define RETADR 30000
#endif
unsigned short *rtad = (unsigned short *)(RETADR);
unsigned short *arg1 = (unsigned short *)(RETADR+2);
unsigned short *arg2 = (unsigned short *)(RETADR+4);
unsigned short *arg3 = (unsigned short *)(RETADR+6);
unsigned short *arg4 = (unsigned short *)(RETADR+8);
unsigned short *arg5 = (unsigned short *)(RETADR+10);
unsigned short *arg6 = (unsigned short *)(RETADR+12);
unsigned short *arg7 = (unsigned short *)(RETADR+14);
int getcpu(void)
{
#asm
	PUSH	IX
	PUSH	IY
	LD	HL,2DH
	LD	A,(0FCC1H)	;main slot 
	CALL	0CH	;RDSLT get MSX version
	EI		;need !!!
	CP	3
	JR	NC,R800M2
	LD	H,0
	LD	L,0
	JR	OWW
R800M2:
	LD	A,081H
	LD	IX,00183H	;GETCPU(0183H/MAIN)
	LD	IY,(0FCC0H)
	CALL	01CH		;CALSLT
	LD	H,0
	LD	L,A
	LD	(30000),HL
OWW:
	POP	IY
	POP	IX
#endasm
  return (int)(*rtad);
}

void di(void)
{
#asm
	DI
#endasm
}

void ei(void)
{
#asm
	EI
#endasm
}

void cls(void)
{
#asm
	PUSH	IX
	PUSH	IY
	XOR	A
	LD 	IX,00C3H	;MSX BIOS CLS(00C3H)
	LD 	IY,(0FCC0H)
	CALL 	001CH
	POP	IY
	POP	IX
#endasm
}

void chput(unsigned char c)
{
/*
	POP	DE	
	POP	HL
	LD	A,L
	PUSH	HL
	PUSH	DE
*/
  *arg1 = (unsigned short)c;
#asm

	PUSH	IX
	PUSH	IY
	LD	A,(30002)
	LD IX,00A2H
	LD IY,(0FCC0H)
	CALL 001CH

	POP	IY
	POP	IX
#endasm
}

void sound(char a,unsigned char b)
{
  di();
  out(0xa0,a);
  out(0xa1,b);
  ei();
}

void vpoke(unsigned adr,unsigned char a)
{
  *arg1 = (unsigned short)adr;
  *arg2 = (unsigned short)a;
#asm
	xor 	a
	di
	out (99h),a
	ld a,08eh
	out (99h),a

	ld a,(30002)
	out (99h),a
	ld a,(30003)
	and 03fh
	or 40h
	out (99h),a
	LD	A,(30004)
	out (98h),a
	ei
#endasm
}

void erafnk(void)
{
#asm
	PUSH	IX
	PUSH	IY
	LD IX,00CCH
	LD IY,(0FCC0H)
	CALL 001CH
	POP	IY
	POP	IX
#endasm
}

void color(char flont,char back,char syuuhen)
{
  char *forclr,*bakclr,*bdrclr;
  forclr = (char *)0xf3e9;
  bakclr = (char *)0xf3ea;
  bdrclr = (char *)0xf3eb;
  *forclr = flont;
  *bakclr = back;
  *bdrclr = syuuhen;
#asm
	PUSH	IX
	PUSH	IY
	ld ix,0062h	;MSX BIOS CHGCLR
	ld iy,(0fcc0h)
	call 001ch
	POP	IY
	POP	IX
#endasm
}

void locate(char x,char y)
{
  char *f3dd;
  char *f3dc;
  f3dd = (char *)0xf3dd; /* MSX work area CSRX(F3DDH,1) */
  f3dc = (char *)0xf3dc; /* MSX work area CSRY(F3DCH,1) */
  *f3dd = x;
  *f3dc = y;
}

void screen(char mode)
{
  *arg1 = (unsigned short)mode;
/*
	POP	DE	
	POP	HL
	PUSH	HL
	PUSH	DE
*/
#asm
	PUSH	IX
	PUSH	IY
	LD	A,(30002)
	ld	ix,005fh
	ld	iy,(0fcc0h)	;MSX BIOS(CHGMOD(005FH)
	call	001ch

	POP	IY
	POP	IX
#endasm
}

char gtstck(char m)
{
/*
	POP	DE
	POP	HL
	PUSH	HL
	PUSH	DE
*/
  *arg1 = (unsigned short)m;
#asm
	PUSH	IX
	PUSH	IY
	LD	A,(30002)
	LD IX,00D5H
	LD IY,(0FCC0H)
	CALL 001CH
	LD	(30000),A

	POP	IY
	POP	IX
#endasm
  return (char)*rtad;
}

char gttrig(char triger)
{
/*
	POP	DE	
	POP	HL
	PUSH	HL
	PUSH	DE
*/
  *arg1 = (unsigned short)triger;
#asm
	PUSH	IX
	PUSH	IY
	LD	A,L
	LD	A,(30002)
	LD IX,00D8H
	LD IY,(0FCC0H)
	CALL 001CH
	LD	(30000),A
	POP	IY
	POP	IX
#endasm
  return (char)*rtad;
}

/* check Ctrl+STOP key */
char breakx(void)
{
#asm
	PUSH	IX
	PUSH	IY
	LD 	IX,00B7H	;MSX BIOS BREAKX(00B7H)
	LD 	IY,(0FCC0H)
	CALL 	001CH
	SBC	A,A
	AND	1
	LD	(30000),A
	POP	IY
	POP	IX
#endasm
	return (char)*rtad;
}


